﻿# Задачи

## READ.ME

* [ ] в Read.Me оставить только рекламу продукта
* [ ] Перевести Read.Me на английский язык
* [ ] Пособие по сборке и внутреннюю кухню вынести в вики
* [ ] Рекламная страница на собственном сайте


## Файлы исходного кода

* [x] файлы хранить в кодировке ANSI
* [ ] Использовать оператор переноса для строк кода больше 80 символов
* [ ] Удалить подключения неиспользуемых заголовочных файлы


## Юникод

* [x] к строковым литералам применять макрос `__TEXT` или `WStr()`
* [x] юникодные функции и структуры должны быть с W на конце, неюникодные — с A.
* [x] все интерфейсы работают только с юникодными строками


## Сборка

* [x] Пакетный файл настройки путей к цепочке инструментов сборки
* [x] Makefile для сборки с учётом путей к файлам `\` и `/` и в команде `move`
* [x] файл с зависимостями
* [x] сборка через GCC
* [x] сборка через LLVM и шланг
* [ ] предварительно скомпилированные заголовочники


## Создание и уничтожение объектов

[x] Уничтожение объектов в обратном порядке: сначала освобождают ссылки на внешние объекты, затем на внутренние
[x] Слабые ссылки для глобальных объектов
[ ] Пул объектов: `HeapMemoryAllocator`, `HttpReader`, `NetworkStream`.
[ ] Размер пула не задан: объекты создаются в обход пула
[ ] Размер пула задан: расширять или не расширять пул


## Асинхронность

Использовать асинхронные функции:

* [x] AcceptEx
* [ ] ConnectEx
* [ ] DisconnectEx
* [x] TransmitPackets
* [x] WSARecv
* [x] Асинхронное чтение файлов
* [x] Асинхронная запись файлов


## Строки

* [x] тип данных строк, существующих в частной куче
* [x] интерфейсы существующие в куче возвращают строки из кучи


## Методы

Стандартные запросы:

* [ ] CONNECT
* [x] DELETE
* [x] GET
* [x] HEAD
* [x] OPTIONS
* [ ] POST
* [ ] PATCH
* [x] PUT
* [x] TRACE

WebDAV:

* [ ] COPY
* [ ] LOCK
* [ ] MKCOL
* [ ] MOVE
* [ ] PROPFIND
* [ ] PROPPATCH
* [ ] UNLOCK

https://webconcepts.info/concepts/http-method/


## Сделать

Эти задачи выполнить в любом порядке.

* [ ] Специальная функция для сравнение строк HeapBSTR, вместо сравнения через lstrcmp или memcmp
* [ ] Проверить на переполнение буферов от функции WideCharToMultiByte
* [ ] Проверить на переполнение буферов от функции lstrcpy
* [x] Ошибка 500 при запросе файла без слэша, а должна быть 404
* [x] Реэнтерабельные функции‐члены объектов из разных потоков.
* [ ] Приводить все NULL к указателю на конкретный тип данных
* [x] Документировать все успешные возвращаемые значения для функций и интерфейсов.
* [ ] Найти все магические числа и заменить на именованные константы.
* [ ] Улучшение производительности: хранение заголовков запроса и ответа в виде двоичного дерева.
* [ ] Кеширование файлов.
* [ ] Различать версию HTTP/1.0 и HTTP/1.1, отдавать соответствующие заголовки.
* [ ] Хранить нераспознанные заголовки запроса.
* [ ] Журналирование запросов.
* [ ] Добавить возможность парольных ресурсов.
* [x] Все коды ошибок WinAPI с описанием отправлять клиенту.
* [x] Новый объект Uri, учитывающий Scheme, Authority, Path, Query, Fragment.
* [ ] Проверить функцию раскодировки URL, возможно, есть библиотечная.
* [x] Загружать виртуальную таблицу статически.
* [x] Новый интерфейс объекта сервера: функции приостановки, возобновления работы. Функция Run не должжна блокировать поток.
* [x] Передача на сервер через PUT очень больших файлов.
* [x] Исправить предупреждения о присвоении указателей разных типов на реальные функции виртуальных таблиц интерфейсов.
* [x] Поддержка в запросе множественных байтовых диапазонов.
* [x] Исправить перемотку видеофайлов.
* [ ] Асинхронный трубопровод в CGI.
* [x] Поддержка заголовка `Expect: 100-continue` и кода `100 Continue`.


## Согласование содержимого

Согласование содержимого по заголовкам:

* [ ] Accept (миме и типы содержимого)
* [ ] Accept-Charset (кодировка текста)
* [x] Accept-Encoding (сжатие gzip, deflate)
* [ ] Accept-Language (язык документа)
* [ ] User-Agent (тип браузёра)


## Контроль жизни объектов

* [x] Возвращать слабые ссылки на коллекцию сайтов
* [x] Возвращать слабые ссылки на коллекцию обработчиков запроса
* [x] Атомарный и неатомарный счётчики ссылок где это нужно.
* [ ] Умные указатели для объектов ядра системы.
* [ ] Умные указатели для интерфейсов.
